#ifndef _JPEG_TO_MJPEGTOOLS_YUV_H_
#define _JPEG_TO_MJPEGTOOLS_YUV_H_


#define _GNU_SOURCE

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <errno.h>
#include <unistd.h>
#include <setjmp.h>
#include <sys/stat.h>

#include "x11.h"

#include <jpeglib.h>

/* timeouts */

/* global vars */
int debug_flag;
int quiet_flag;
int manual_flag;
int no_color_flag;
int color_depth;
int color_depth_mode;
int x_display;
int window_open_flag;
char *xbuffer;

char *jpeg_buffer; // the jpeg picture data
int content_length;

int seconds_per_frame;

int yuv_header_send_flag;

unsigned char *rgb24_buffer;
unsigned char *yuv_buffer;
unsigned char *yuv_buffer_prev;
int time_flag;
int clock_position;
int use_utc_flag;
int report_read_timeout_flag;

int jpg_number;

double **up;
double **vp;

// this last, so all things are defined.
#include "jpg_to_mjpegtools_yuv_proto.h"

/* CCIR spec, taken from ffmpeg source, to match their colors */
#define SCALEBITS 10
#define FIX(x)    ((int) ((x) * (1<<SCALEBITS) + 0.5))
#define ONE_HALF  (1 << (SCALEBITS - 1))

#define RGB_TO_Y_CCIR(r, g, b) \
((FIX(0.29900*219.0/255.0) * (r) + FIX(0.58700*219.0/255.0) * (g) + \
  FIX(0.11400*219.0/255.0) * (b) + (ONE_HALF + (16 << SCALEBITS))) >> SCALEBITS)

#define RGB_TO_U_CCIR(r1, g1, b1, shift)\
(((- FIX(0.16874*224.0/255.0) * r1 - FIX(0.33126*224.0/255.0) * g1 +         \
     FIX(0.50000*224.0/255.0) * b1 + (ONE_HALF << shift) - 1) >> (SCALEBITS + shift)) + 128)

#define RGB_TO_V_CCIR(r1, g1, b1, shift)\
(((FIX(0.50000*224.0/255.0) * r1 - FIX(0.41869*224.0/255.0) * g1 -           \
   FIX(0.08131*224.0/255.0) * b1 + (ONE_HALF << shift) - 1) >> (SCALEBITS + shift)) + 128)


#define DEFAULT_SECONDS_PER_FRAME	10
#define PVERSION					"0.2.2"


#endif /* _JPEG_TO_MJPEGTOOLS_YUV_H_ */

